/* Marek Handl
 * CS321 - Computer Graphics
 * Lab 5
 * October 2006
 */

#ifndef VIEWCONTEXT_H
#define VIEWCONTEXT_H

#include <iostream>
#include <qpoint.h>
#include <vector>
#include "matrix.h"


using namespace std;
using namespace math;

class ViewContext {
	private:
	double scaleFactor;
	double theta;
	double xpos;
	double ypos;
	matrix<float> T;
	matrix<float> S;
	matrix<float> transMatrix;
	matrix<float> invMatrix;
	bool reseting;	// store min-max values, do not draw
	long min_x, min_y, max_x, max_y;

	void MakeIdentityMatrix( matrix<float> &m );
	
	public:
	ViewContext();
	~ViewContext();

	QPoint WindowToModel( QPoint modelPoint ) const;
	QPoint ModelToWindow( QPoint modelPoint );
	void SetRotation( double theta );
	void SetPosition( QPoint p );
	void SetScale( double sf );

	void ComputeMatrices();
	void Reset();

	void SetReseting( bool res );
	bool GetReseting() const;
	void ComputeReseting( int width, int height );
	
	double GetTheta() const;
	double GetXpos() const;
	double GetYpos() const;
	
};

#endif