/* Marek Handl
 * CS321 - Computer Graphics
 * Lab 5
 * October 2006
 */

#ifndef BEZIER_H
#define BEZIER_H
#include "variable_shape.h"
#include <qwidget.h>
#include <qcolor.h>
#include <qpointarray.h>

// polygon object represents one polygon shape
// each polygon belongs to a certain image
// interface is derived from abstract class "VariableShape"
class bezier : public VariableShape
{
	protected:
	int numberOfFacets;
	int counter_value;	// shape ID

	public:
	bezier( int numFacets, Qt::PenStyle ps, QColor col ); // constructor
	bezier( const bezier& b );			// copy-constructor
	~bezier();				// destructor

	void Draw( QWidget *drawArea, ViewContext *viewContext ) const;
	void Write( std::ostream& ostr ) const;	// Output shape to file
	void Read( std::istream& istr );	// Input shape from file
	bezier* Clone() const;			// Return a new copy 
	bezier& operator= ( const bezier& b );

	QPoint getPoint( double mu ) const;
	QPoint getPoint3( double mu) const;
	QPoint getPoint4( double mu) const;
	QPoint getPointN( double mu) const;
};

#endif
