/* Marek Handl
 * CS321 - Computer Graphics
 * Lab 5
 * October 2006
 */

#ifndef LINE_H
#define LINE_H
#include "shape.h"
#include <qwidget.h>
#include <qcolor.h>

// line object represents one line shape
// each line belongs to a certain image
// interface is derived from abstract class "shape"
class line : public shape
{
	protected:
	int x0;		// start point
	int y0;		// start point
	int x1;		// end point
	int y1;		// end point
	int counter_value;	// shape ID

	public:
	line( int X0, int Y0, int X1, int Y0, Qt::PenStyle ps, QColor col ); // constructor
	line( const line& l );			// copy-constructor
	~line();				// destructor

	void Draw( QWidget *drawArea, ViewContext *viewContext ) const;
	void Write( std::ostream& ostr ) const;	// Output shape to file
	void Read( std::istream& istr );	// Input shape from file
	line* Clone() const;			// Return a new copy
	line& operator= ( const line& l );
};

#endif
