/* Marek Handl
 * CS321 - Computer Graphics
 * Lab 5
 * October 2006
 */

#ifndef POINT_H
#define POINT_H
#include <shape.h>
#include <qwidget.h>
#include <qcolor.h>

// point object represents one point
// each point belongs to a certain image
// interface is derived from abstract class "shape"
class point : public shape
{
	protected:
	int x;
	int y;
	int counter_value;		// shape ID

	public:
	point( int X, int Y, Qt::PenStyle ps, QColor col );		// constructor
	point( const point& p );	// copy-constructor
	~point();			// destructor

	void Draw( QWidget *drawArea, ViewContext *viewContext ) const;
	void Write( std::ostream& ostr ) const;	// Output shape to file
	void Read( std::istream& istr );	// Input shape from file
	point* Clone() const;			// Return a new copy
	point& operator= ( const point& p );
};

#endif
