/* Marek Handl
 * CS321 - Computer Graphics
 * Lab 5
 * October 2006
 */

#ifndef POLYGON_H
#define POLYGON_H
#include "variable_shape.h"
#include <qwidget.h>
#include <qcolor.h>
#include <qpointarray.h>

// polygon object represents one polygon shape
// each polygon belongs to a certain image
// interface is derived from abstract class "VariableShape"
class polygon : public VariableShape
{
	protected:
	int counter_value;	// shape ID
	bool nonZeroWinding;
	QColor brushColor;
	Qt::BrushStyle brushStyle;

	public:
	polygon( bool nzw, Qt::PenStyle ps, QColor col, Qt::BrushStyle bs, QColor bcol ); // constructor
	polygon( const polygon& g );			// copy-constructor
	~polygon();				// destructor

	void Draw( QWidget *drawArea, ViewContext *viewContext ) const;
	void Write( std::ostream& ostr ) const;	// Output shape to file
	void Read( std::istream& istr );	// Input shape from file
	polygon* Clone() const;			// Return a new copy 
	polygon& operator= ( const polygon& g );
};

#endif
