/* Marek Handl
 * CS321 - Computer Graphics
 * Lab 5
 * October 2006
 */

#include "variable_shape.h"
#include <iostream>
#include <qpainter.h>
#include <qcolor.h>
#include <qpointarray.h>

using namespace std;

// constructor
VariableShape::VariableShape( char type, Qt::PenStyle ps, QColor col ) : shape( type, ps, col )
{
	// at first shape constructor is called
	vertices = new QPointArray();	// array of vertices
	nextIndex = 0;
}	

// copy-constructor
VariableShape::VariableShape( const VariableShape& v ) : shape( v.type, v.penStyle, v.color )
{
	// at first shape constructor is called
	vertices = new QPointArray();		// create a new empty array of vertices
	vertices = &((v.vertices)->copy());	// copy vertices into the new array
	nextIndex = vertices->size();
}

// destructor
VariableShape::~VariableShape()
{
	delete vertices;
}

// write parameters to output file
void VariableShape::Write( std::ostream& ostr ) const
{
	int numberOfVertices = vertices->size();
	ostr << numberOfVertices;
	for ( int i=0; i<numberOfVertices; i++ )
		ostr << " " << vertices->at(i).x() << " " << vertices->at(i).y();
	ostr << endl;

}

// read parameters from input file
void VariableShape::Read( std::istream& istr )
{
	int numberOfVertices, x, y;
	vertices->resize(0);	// just to make sure there are no vertices in polygon so far
	istr >> numberOfVertices;
	for ( int i=0; i<numberOfVertices; i++ ) {
		istr >> x >> y;
		AddNode( x, y );
	}
}

// overloaded assignment operator
VariableShape& VariableShape::operator= ( const VariableShape& v )
{
	if ( this == &v ) return *this;
	shape::operator=( v );	// color, penStyle, type of shape
	delete vertices;
	vertices = new QPointArray();
	vertices = &((v.vertices)->copy());
	nextIndex = v.nextIndex;
	return *this;
}

// add vertex <x,y> to the array
void VariableShape::AddNode( int x, int y )
{
	vertices->putPoints( nextIndex, 1, x, y );
	nextIndex++;
}
