/* Marek Handl
 * CS321 - Computer Graphics
 * Lab 5
 * October 2006
 */

#ifndef VARSHAPE_H
#define VARSHAPE_H
#include "shape.h"
#include <qwidget.h>
#include <qcolor.h>
#include <qpointarray.h>

// Abstract class
// represents interface for Polygon, Bezier Curves etc.
// holds array of vertices
class VariableShape : public shape
{
	protected:
	QPointArray *vertices;
	int nextIndex;		// index in vertices array where will be next added vertex stored

	public:
	VariableShape( char type, Qt::PenStyle ps, QColor col ); // constructor
	VariableShape( const VariableShape& v );			// copy-constructor
	~VariableShape();				// destructor
	
	void AddNode( int x, int y );		// add vertex <x,y>
	virtual void Draw( QWidget *drawArea, ViewContext *viewContext ) const = 0;
	virtual void Write( std::ostream& ostr ) const;	// Output shape to file
	virtual void Read( std::istream& istr );	// Input shape from file
	virtual VariableShape* Clone() const = 0;			// Return a new copy
	VariableShape& operator= ( const VariableShape& v );
};

#endif
